<?php 

$proxyhost = "localhost";
$proxyport = "8080";

$tpl2php_url = "http://localhost/tpl2http.php";
$hmac_key = "ohnae3Ie";

function is_assoc ($arr) {
	return (is_array($arr) && count(array_filter(array_keys($arr),'is_string')) == count($arr));
}

function getBody() {
	$body = '';
	$fh   = @fopen('php://input', 'r');
	if ($fh) {
  		while (!feof($fh)) {
			$s = fread($fh, 1024);
		    	if (is_string($s)) {
				$body .= $s;
			}
		}
	  	fclose($fh);
	}
	return $body;
}

function new_tpl_var(&$tpl_vars, $attr_value, $is_string=false) {
	$var_name = uniqid();

	if ($is_string) {
		$var_name = "Q_" . $var_name;
	} else {
		$var_name = "__" . $var_name;
	}

	$tpl_vars[$var_name] = $attr_value;
	return '{' . $var_name . '}';
}

function json2tpl($json, &$tpl_vars) {
	if (is_array($json)) {
		$json_tpl = array();
		foreach($json as $key => $value) {
			$tpl_var = new_tpl_var($tpl_vars, $key, true);
			$json_tpl[$tpl_var] = json2tpl($value, $tpl_vars);
		}
		return $json_tpl;
	} else if (is_string($json)) {
		return new_tpl_var($tpl_vars, $json, true);
	} else if (is_int($json)) {
		return new_tpl_var($tpl_vars, $json);
	} else if (is_null($json)) {
		return new_tpl_var($tpl_vars, $json);
	} else if ($json == "true" || $json == "false") {
		return new_tpl_var($tpl_vars, $json);
	} else {
		die ("unexpected json value: " + var_export($json));
	}
}

function mk_tpl_url($tpl2php_url, $ssl, $request_line, $headers, $tpl_body, $tpl_vars) {
	global $hmac_key;

	$dst = array('ssl' => $ssl, 'request_line' => $request_line, 'headers' => $headers, 'tpl_body' => $tpl_body);
	$dst_serialized = serialize($dst);
	$dst_sign = hash_hmac("md5", $dst_serialized, $hmac_key);
	$url = "$tpl2php_url?DST=" . urlencode($dst_serialized) . "&DST_SIGN=$dst_sign";

	foreach ($tpl_vars as $tpl_var_key => $tpl_var_value) {
		$url .= "&BODYTPLVAR_" . urlencode($tpl_var_key) . "=" . urlencode($tpl_var_value);
	}
	return $url;
}

function curl($url) {
	global $proxyhost;
	global $proxyport;

	$ch = curl_init($url);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_HEADER, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_PROXY, "$proxyhost:$proxyport");
	$response = curl_exec($ch);
	curl_close($ch);

	$response_lines = preg_split ("/\r*\n/", $response);
	#var_dump($response_lines);

	$i=0;
	if (preg_match("/^HTTP\/\d+\.\d+ 200 Connection established/", $response_lines[$i])) {
		# this is proxy's response, skip until the next header
		for (; $i<count($response_lines); $i++) {
			$chomped_line = rtrim($response_lines[$i], "\r\n");
			if (strlen($chomped_line) == 0) {
				$i++;
				break;
			}
		}
	}

	$in_header = true;
	for (; $i<count($response_lines); $i++) {
		$line = $response_lines[$i];
		if ($in_header) {
	                if (strlen($line) > 0) {
                        	$is_setcookie = preg_match("/^set-cookie:/i", $line) > 0;
                        	# don't replace set-cookie headers, append them
                        	header($line, !$is_setcookie);
                	} else {
                        	$in_header = false;
                        	#echo "\r\n";
                	}
        	} else {
                	echo "$line";
			if ($i < count($response_lines)-1) {
				# not the last line
                        	echo "\r\n";
			}
        	}
	}
}

#print "--------------------------\n";
$ssl = isset($_SERVER['HTTPS']);
$request_line = $_SERVER['REQUEST_METHOD'] . " " . $_SERVER['REQUEST_URI'] . " " . $_SERVER['SERVER_PROTOCOL'];
$headers = getallheaders();
$body = getBody();
#var_dump($headers);
#var_dump($body);

$tpl_vars = array();

#####################################################################
### Customize the code below to support proprietary input formats ###
#####################################################################

## try decoding JSON from the body
$json = json_decode($body, true);
if (!is_null($json)) {
	## found JSON in the body!
	$tpl_json = json2tpl($json, $tpl_vars);
	$tpl_body = json_encode($tpl_json, JSON_FORCE_OBJECT);
}

## try decoding JSON from the parameter from the body called 'JSON'
if (is_null($tpl_json)) {
	if (preg_match("/^JSON=\[([^\]]*)\]&(.*)$/", $body, $matches)) {
		#var_dump($matches);
		$json = json_decode(urldecode($matches[1]), true);
		if (!is_null($json)) {
			## found JSON stuff!
			$tpl_json = json2tpl($json, $tpl_vars);
			$stuff = json_encode($tpl_json, JSON_FORCE_OBJECT);
			$tpl_body = "JSON=[" . urlencode($stuff) . "]&".$matches[2];
			#var_dump($tpl_body);
		}
	}
}

## nothing found?
if (is_null($tpl_json)) {
	$tpl_body = $body;
}

################################################################
################################################################
################################################################

## try decoding JSON from the body
$json = json_decode($body, true);
if (!is_null($json)) {
	## found JSON in the body!
	$tpl_json = json2tpl($json, $tpl_vars);
	$tpl_body = json_encode($tpl_json, JSON_FORCE_OBJECT);
}

## try decoding JSON from the POST parameter
if (is_null($tpl_json) && !is_null($_POST['JSON'])) {
	$json = json_decode($_POST['JSON'], true);
	if (!is_null($json)) {
		## found JSON in the parameter!
		$json = $json[0]; ## remove outter array
		$tpl_json = json2tpl($json, $tpl_vars);
		$stuff = json_encode($tpl_json, JSON_FORCE_OBJECT);
		$tpl_body = "POST=[" . urlencode($stuff) . "]";
	}
}

## nothing found?
if (is_null($tpl_json)) {
	$tpl_body = $body;
}

#var_dump($body);
#var_dump($json);
#var_dump($tpl_json);
#var_dump($tpl_body);

#var_dump($body);
#var_dump($json);
#var_dump($tpl_json);
#var_dump($tpl_body);

$tpl_url = mk_tpl_url($tpl2php_url, $ssl, $request_line, $headers, $tpl_body, $tpl_vars);

#print "--------------------------\n";
#var_dump($headers);
#var_dump($tpl_body);
#var_dump($tpl_vars);
#var_dump($tpl_url);

curl($tpl_url);

?>
